GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | List of all members
OGRTriangulatedSurface Class Reference

TriangulatedSurface class. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRTriangulatedSurface:

## Public Types
typedef OGRTriangle | ChildType
| Type of child elements. More...
Public Types inherited from OGRPolyhedralSurface
typedef OGRPolygon | ChildType
| Type of child elements. More...

## Public Member Functions
| OGRTriangulatedSurface ()
| Constructor.
| OGRTriangulatedSurface (const OGRTriangulatedSurface &other)
| Copy constructor.
| ~OGRTriangulatedSurface ()
| Destructor. More...
ChildType ** | begin ()
| Return begin of iterator. More...
ChildType ** | end ()
| Return end of iterator.
const ChildType *const * | begin () const
| Return begin of iterator. More...
const ChildType *const * | end () const
| Return end of iterator.
OGRTriangulatedSurface & | operator= (const OGRTriangulatedSurface &other)
| Assignment operator.
virtual const char * | getGeometryName () const override
| Returns the geometry name of the TriangulatedSurface. More...
virtual OGRwkbGeometryType | getGeometryType () const override
| Returns the WKB Type of TriangulatedSurface. More...
virtual OGRErr | addGeometry (const OGRGeometry *) override
| Add a new geometry to a collection. More...
OGRPolyhedralSurface * | toUpperClass ()
| Return pointer of this in upper class.
const OGRPolyhedralSurface * | toUpperClass () const
| Return pointer of this in upper class.
virtual void | accept (IOGRGeometryVisitor *visitor) override
| Accept a visitor. More...
virtual void | accept (IOGRConstGeometryVisitor *visitor) const override
| Accept a visitor. More...
Public Member Functions inherited from OGRPolyhedralSurface
| OGRPolyhedralSurface ()
| Create an empty PolyhedralSurface.
| OGRPolyhedralSurface (const OGRPolyhedralSurface &poGeom)
| Copy constructor.
| ~OGRPolyhedralSurface () override
| Destructor. More...
OGRPolyhedralSurface & | operator= (const OGRPolyhedralSurface &other)
| Assignment operator.
ChildType ** | begin ()
| Return begin of iterator. More...
ChildType ** | end ()
| Return end of iterator.
const ChildType *const * | begin () const
| Return begin of iterator. More...
const ChildType *const * | end () const
| Return end of iterator.
virtual int | WkbSize () const override
| Returns size of related binary representation. More...
virtual OGRErr | importFromWkb (const unsigned char *, int, OGRwkbVariant, int &nBytesConsumedOut) override
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const override
| Convert a geometry into well known binary format. More...
OGRErr | importFromWkt (const char **) override
| deprecated
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const override
| Convert a geometry into well known text format. More...
virtual int | getDimension () const override
| Get the dimension of this object. More...
virtual void | empty () override
| Clear geometry information. More...
virtual OGRGeometry * | clone () const override
| Make a copy of this object. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const override
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const override
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual void | flattenTo2D () override
| Convert geometry to strictly 2D. More...
virtual OGRErr | transform (OGRCoordinateTransformation *) override
| Apply arbitrary coordinate transformation to geometry. More...
virtual OGRBoolean | Equals (const OGRGeometry *) const override
| Returns TRUE if two geometries are equivalent. More...
virtual double | get_Area () const override
| Returns the area enclosed. More...
virtual OGRErr | PointOnSurface (OGRPoint *) const override
| This method relates to the SFCOM ISurface::get_PointOnSurface() method. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const override
| Returns if this geometry is or has curve geometry. More...
OGRErr | addGeometryDirectly (OGRGeometry *poNewGeom)
| Add a geometry directly to the container. More...
int | getNumGeometries () const
| Fetch number of geometries in PolyhedralSurface. More...
OGRGeometry * | getGeometryRef (int i)
| Fetch geometry from container. More...
const OGRGeometry * | getGeometryRef (int i) const
| Fetch geometry from container. More...
virtual OGRBoolean | IsEmpty () const override
| Checks if the PolyhedralSurface is empty. More...
virtual void | setCoordinateDimension (int nDimension) override
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D) override
| Set the type as 3D geometry.
virtual void | setMeasured (OGRBoolean bIsMeasured) override
| Set the type as Measured.
virtual void | swapXY () override
| Swap x and y coordinates.
OGRErr | removeGeometry (int iIndex, int bDelete=TRUE)
| Remove a geometry from the container. More...
virtual void | assignSpatialReference (OGRSpatialReference *poSR) override
| Assign spatial reference to this object. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
bool | operator== (const OGRGeometry &other) const
| Returns if two geometries are equal. More...
bool | operator!= (const OGRGeometry &other) const
| Returns if two geometries are different. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRErr | importFromWkb (const GByte *, int=-1, OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
OGRErr | importFromWkt (char **ppszInput) CPL_WARN_DEPRECATED("Use importFromWkt( const char**) instead")
| Deprecated. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=nullptr, char **papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=nullptr) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=nullptr) const CPL_WARN_UNUSED_RESULT
| Return curve version of this geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const CPL_WARN_UNUSED_RESULT
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | closeRings ()
| Force rings to be closed. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...
OGRPoint * | toPoint ()
| Down-cast to OGRPoint*. More...
const OGRPoint * | toPoint () const
| Down-cast to OGRPoint*. More...
OGRCurve * | toCurve ()
| Down-cast to OGRCurve*. More...
const OGRCurve * | toCurve () const
| Down-cast to OGRCurve*. More...
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*. More...
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*. More...
OGRLineString * | toLineString ()
| Down-cast to OGRLineString*. More...
const OGRLineString * | toLineString () const
| Down-cast to OGRLineString*. More...
OGRLinearRing * | toLinearRing ()
| Down-cast to OGRLinearRing*. More...
const OGRLinearRing * | toLinearRing () const
| Down-cast to OGRLinearRing*. More...
OGRCircularString * | toCircularString ()
| Down-cast to OGRCircularString*. More...
const OGRCircularString * | toCircularString () const
| Down-cast to OGRCircularString*. More...
OGRCompoundCurve * | toCompoundCurve ()
| Down-cast to OGRCompoundCurve*. More...
const OGRCompoundCurve * | toCompoundCurve () const
| Down-cast to OGRCompoundCurve*. More...
OGRSurface * | toSurface ()
| Down-cast to OGRSurface*. More...
const OGRSurface * | toSurface () const
| Down-cast to OGRSurface*. More...
OGRPolygon * | toPolygon ()
| Down-cast to OGRPolygon*. More...
const OGRPolygon * | toPolygon () const
| Down-cast to OGRPolygon*. More...
OGRTriangle * | toTriangle ()
| Down-cast to OGRTriangle*. More...
const OGRTriangle * | toTriangle () const
| Down-cast to OGRTriangle*. More...
OGRCurvePolygon * | toCurvePolygon ()
| Down-cast to OGRCurvePolygon*. More...
const OGRCurvePolygon * | toCurvePolygon () const
| Down-cast to OGRCurvePolygon*. More...
OGRGeometryCollection * | toGeometryCollection ()
| Down-cast to OGRGeometryCollection*. More...
const OGRGeometryCollection * | toGeometryCollection () const
| Down-cast to OGRGeometryCollection*. More...
OGRMultiPoint * | toMultiPoint ()
| Down-cast to OGRMultiPoint*. More...
const OGRMultiPoint * | toMultiPoint () const
| Down-cast to OGRMultiPoint*. More...
OGRMultiLineString * | toMultiLineString ()
| Down-cast to OGRMultiLineString*. More...
const OGRMultiLineString * | toMultiLineString () const
| Down-cast to OGRMultiLineString*. More...
OGRMultiPolygon * | toMultiPolygon ()
| Down-cast to OGRMultiPolygon*. More...
const OGRMultiPolygon * | toMultiPolygon () const
| Down-cast to OGRMultiPolygon*. More...
OGRMultiCurve * | toMultiCurve ()
| Down-cast to OGRMultiCurve*. More...
const OGRMultiCurve * | toMultiCurve () const
| Down-cast to OGRMultiCurve*. More...
OGRMultiSurface * | toMultiSurface ()
| Down-cast to OGRMultiSurface*. More...
const OGRMultiSurface * | toMultiSurface () const
| Down-cast to OGRMultiSurface*. More...
OGRPolyhedralSurface * | toPolyhedralSurface ()
| Down-cast to OGRPolyhedralSurface*. More...
const OGRPolyhedralSurface * | toPolyhedralSurface () const
| Down-cast to OGRPolyhedralSurface*. More...
OGRTriangulatedSurface * | toTriangulatedSurface ()
| Down-cast to OGRTriangulatedSurface*. More...
const OGRTriangulatedSurface * | toTriangulatedSurface () const
| Down-cast to OGRTriangulatedSurface*. More...

## Static Public Member Functions
static OGRPolyhedralSurface * | CastToPolyhedralSurface (OGRTriangulatedSurface *poTS)
| Casts the OGRTriangulatedSurface to an OGRPolyhedralSurface. More...
Static Public Member Functions inherited from OGRPolyhedralSurface
static OGRMultiPolygon * | CastToMultiPolygon (OGRPolyhedralSurface *poPS)
| Casts the OGRPolyhedralSurface to an OGRMultiPolygon. More...
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
static OGRGeometryH | ToHandle (OGRGeometry *poGeom)
| Convert a OGRGeometry* to a OGRGeometryH. More...
static OGRGeometry * | FromHandle (OGRGeometryH hGeom)
| Convert a OGRGeometryH to a OGRGeometry*. More...

## Detailed Description

TriangulatedSurface class.

Since
  GDAL 2.2

## Member Typedef Documentation

typedef OGRTriangle OGRTriangulatedSurface::ChildType

Type of child elements.

## Constructor & Destructor Documentation

OGRTriangulatedSurface::~OGRTriangulatedSurface | ( |  | ) |
| default

Destructor.

## Member Function Documentation

virtual void OGRTriangulatedSurface::accept | ( | IOGRGeometryVisitor * | visitor | ) |
| inline override virtual

Accept a visitor.

Reimplemented from OGRPolyhedralSurface.

virtual void OGRTriangulatedSurface::accept | ( | IOGRConstGeometryVisitor * | visitor | ) | const
| inline override virtual

Accept a visitor.

Reimplemented from OGRPolyhedralSurface.

OGRErr OGRTriangulatedSurface::addGeometry | ( | const OGRGeometry * | poNewGeom | ) |
| override virtual

Add a new geometry to a collection.

Only a POLYGON can be added to a POLYHEDRALSURFACE.

Returns
  OGRErr OGRERR_NONE if the polygon is successfully added

Reimplemented from OGRPolyhedralSurface.

ChildType** OGRTriangulatedSurface::begin | ( |  | ) |
| inline

Return begin of iterator.

Since
  GDAL 2.3

const ChildType* const* OGRTriangulatedSurface::begin | ( |  | ) | const
| inline

Return begin of iterator.

Since
  GDAL 2.3

OGRPolyhedralSurface * OGRTriangulatedSurface::CastToPolyhedralSurface | ( | OGRTriangulatedSurface * | poTS | ) |
| static

Casts the OGRTriangulatedSurface to an OGRPolyhedralSurface.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poTS | the input geometry - ownership is passed to the method.

Returns
  new geometry.

const char * OGRTriangulatedSurface::getGeometryName | ( |  | ) | const
| override virtual

Returns the geometry name of the TriangulatedSurface.

Returns
  "TIN"

Reimplemented from OGRPolyhedralSurface.

OGRwkbGeometryType OGRTriangulatedSurface::getGeometryType | ( |  | ) | const
| override virtual

Returns the WKB Type of TriangulatedSurface.

Reimplemented from OGRPolyhedralSurface.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrtriangulatedsurface.cpp

Generated for GDAL by 1.8.8.